#include "stdafx.h"
#include "Cell.h"

#ifndef __ELEMENT_H__
#define __ELEMENT_H__

#ifdef WIN32
#pragma pack(push, 1)
#endif

class LNElement {
	public:
		// actual cell in grid
		LNCell cell;

		// cytokines/chemokines floating around

};


enum GRElementTypes { ELEMENT_OPEN = 0, ELEMENT_TISSUE = 1, 
	ELEMENT_BLOOD = 2, ELEMENT_LYMPHATIC = 3, NUMELEMENTTYPES = 4
};

class GRElement {
	public:
		// for GR we are trying to save memory a bit, so will not store cell directly
		// implement later

		// actual cell in grid
		GRCell cell;
		
		// properties
	//	u32 cellid:26; // 0-64mil
	//	u32 celltype:4; // 0-15
		u32 elementtype:2; // 0-3
		//GRElementTypes type:2;

		// cytokines/chemokines floating around

};


enum ChemTypes { CHEM_TNF = 0, CHEM_CCL2 = 1, 
	CHEM_CCL5 = 2, CHEM_CXCL9 = 3, CHEM_EXTMTB = 4, NUM_CHEMTYPES = 5
};
#define DIFFUSETYPE	float
class GRDiffuse {
	public:
		DIFFUSETYPE curr[NUM_CHEMTYPES], next[NUM_CHEMTYPES];
/*		DIFFUSETYPE tnf, next_tnf; //Range: 0  10^6 or more
		DIFFUSETYPE ccl2, next_ccl2; //Range: 0  10^6 or more
		DIFFUSETYPE ccl5, next_ccl5; //Range: 0  10^6 or more
		DIFFUSETYPE cxcl9, next_cxcl9; //Range: 0  10^6 or more
		DIFFUSETYPE extMtb, next_extMtb; //Range: 0  100 or more*/
};

#ifdef WIN32
#pragma pack(pop)
#endif

#endif
