#include "stdafx.h"
#include "VizGrid.h"

bool ENABLE_FRC = false;
bool ENABLE_OUTLINE = false;

void LNGrid::InitStructure() {
	LNCell nogo;
	mfpsum = 0.0f;
	nummfp = 0.0f;
	nogo.celltype = GRID_NOGO;
	nogo.displaybig = false;
	nogo.lastdir = 0;
	int numnogo = 0;
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				grid[x][y][z].cell.celltype = CELL_NONE;
			}
		}
	}

	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				// generate no-go zones
				if ((pow((float)(y - LN_GRID_Y / 2), 2) + pow((float)(z - LN_GRID_Z / 2), 2)) > 580) // 20 units = 400, 25 = 625
					grid[x][y][z].cell = nogo;
				if (x < 25 && (pow((float)(x - 25), 2) + pow((float)(y - LN_GRID_Y / 2), 2) + pow((float)(z - LN_GRID_Z / 2), 2)) > 600)
					grid[x][y][z].cell = nogo;
				if (x > (LN_GRID_X - 25) && (pow((float)(x - (LN_GRID_X - 25)), 2) + pow((float)(y - LN_GRID_Y / 2), 2) + pow((float)(z - LN_GRID_Z / 2), 2)) > 600)
					grid[x][y][z].cell = nogo;

				if (grid[x][y][z].cell.celltype == GRID_NOGO)
					numnogo++;
			}
		}
	}
	printf("No-go zones: %d/%d = %0.2f%%\n", numnogo, LN_GRID_X*LN_GRID_Y*LN_GRID_Z, 100.0f * (float)numnogo/(float)(LN_GRID_X*LN_GRID_Y*LN_GRID_Z));

	// generate FRC
	int numfrc = FRC_generator(100);
	printf("FRC generated, %d/%d = %0.2f%%\n", numfrc, LN_GRID_X*LN_GRID_Y*LN_GRID_Z - numnogo, 100.0f * (float)numfrc/(float)(LN_GRID_X*LN_GRID_Y*LN_GRID_Z - numnogo));

	// setup ALs and HEVs and ELs
	coord temp;
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				if (y == LN_GRID_Y - 9) {
					if ((x + 8) % 16 == 0 && (z + 4) % 16 == 0) { // 32 & 16
						if (grid[x][y][z].cell.celltype == CELL_NONE) {
							temp.x = x; temp.y = y; temp.z = z;
							als.push_back(temp);
							grid[x][y][z].cell.celltype = INPUT_AFFERENT;
							grid[x][y][z].cell.displaybig = true;
						}
					}
				}
				if (y == LN_GRID_Y - 5) {
					if ((x + 2) % 8 == 0 && (z + 1) % 4 == 0) {
						if (grid[x][y][z].cell.celltype == CELL_NONE) {
							temp.x = x; temp.y = y; temp.z = z;
							hevs.push_back(temp);
							grid[x][y][z].cell.celltype = INPUT_HEV;
							grid[x][y][z].cell.displaybig = true;
						}
					}
				}
				if (y == LN_GRID_Y - 7) {
					if ((x + 6) % 8 == 0 && (z + 3) % 4 == 0) {
						if (grid[x][y][z].cell.celltype == CELL_NONE) {
							temp.x = x; temp.y = y; temp.z = z;
							hevs.push_back(temp);
							grid[x][y][z].cell.celltype = INPUT_HEV;
							grid[x][y][z].cell.displaybig = true;
						}
					}
				}
				if (y == 4) {
					if ((x + 1) % 4 == 0 && (z + 0) % 2 == 0) {
						if (grid[x][y][z].cell.celltype == CELL_NONE) {
							temp.x = x; temp.y = y; temp.z = z;
							els.push_back(temp);
							grid[x][y][z].cell.celltype = OUTPUT_EFFERENT;
							grid[x][y][z].cell.displaybig = true;
						}
					}
				}
				if (y == 6) {
					if ((x + 3) % 4 == 0 && (z + 1) % 2 == 0) {
						if (grid[x][y][z].cell.celltype == CELL_NONE) {
							temp.x = x; temp.y = y; temp.z = z;
							els.push_back(temp);
							grid[x][y][z].cell.celltype = OUTPUT_EFFERENT;
							grid[x][y][z].cell.displaybig = true;
						}
					}
				}
			}
		}
	}

	printf("ALs: %d, HEVs: %d, ELs: %d\n\n", als.size(), hevs.size(), els.size());
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				if (grid[x][y][z].cell.celltype == CELL_NONE) {
					grid[x][y][z].cell.displaybig = (rnd.getfloat() > 0.998) ? 1 : 0;
					grid[x][y][z].cell.lastdir = rnd.get(1) % 27;
					grid[x][y][z].cell.cognate = (rnd.get_inrange(1, 300) == 1) ? true : false;
				//	grid[x][y][z].cell.dc_bound = false;
					grid[x][y][z].cell.dc_bound_time = 0;
					grid[x][y][z].cell.division_counter = 0;
					grid[x][y][z].cell.priming_history = 0;
					grid[x][y][z].cell.hide_time = 0;
					//grid[x][y][z].cell.movedyet = false;
					float typerand = rnd.getfloat();
					
					#ifdef INITIALFILL
					if (typerand < 0.20) { // 0.30
						grid[x][y][z].cell.celltype = CELL_H;
						grid[x][y][z].cell.birth_time = timeindex - rnd.get_inrange(CD4_MIN_AGE, CD4_MAX_AGE);
						grid[x][y][z].cell.death_time = grid[x][y][z].cell.birth_time + rnd.getnormal(CD4_MAX_AGE, CD4_MAX_AGE_STD);
						grid[x][y][z].cell.state = HCELL_RESTING;
						grid[x][y][z].cell.next_state = HCELL_RESTING;
					} else if (typerand < 0.36) { // 0.55
						grid[x][y][z].cell.celltype = CELL_K;
						grid[x][y][z].cell.birth_time = timeindex - rnd.get_inrange(CD8_MIN_AGE, CD8_MAX_AGE);
						grid[x][y][z].cell.death_time = grid[x][y][z].cell.birth_time + rnd.getnormal(CD8_MAX_AGE, CD8_MAX_AGE_STD);
						grid[x][y][z].cell.state = KCELL_RESTING;
						grid[x][y][z].cell.next_state = KCELL_RESTING;
				//	} else if (typerand < 0.3601) { // 0.5501 - none on the grid initially
					//if (typerand < 0.0001) {
				//		grid[x][y][z].cell.celltype = CELL_D;
				//		grid[x][y][z].cell.displaybig = 1;
					} else
					#endif
						grid[x][y][z].cell.celltype = CELL_NONE;

					grid[x][y][z].cell.enter_time = timeindex;
					grid[x][y][z].cell.mfp = MFP_UNIT;
					totalcells[grid[x][y][z].cell.celltype]++;
				}
			}
		}
	}
}

bool LNGrid::CalcTimeSlice(int slice) { // now 6 seconds per slice, 3 per 18s // 6 seconds per slice, 20 per 2 minutes
	timeindex = slice;
/*	if (slice % 20 == 0) { // yes
		ClearMoved();
		Recruitment();
		Movement();
		States();
		ClearDead();

		printf(" %0.1fh: [HT] %d, [KT] %d, [DC] %d\n", (float)timeindex/600.0, totalcells[CELL_H], totalcells[CELL_K], totalcells[CELL_D]);
		if (totalcellslost > 0)
			printf("  Avg grid time: %0.1fh\n", (float)totalgridtime/(float)(totalcellslost * 600));
	
		return true;
	}*/
	if (slice % 3 == 0) { // T cells
		ClearMoved();
		Recruitment();
		Movement();
		States();
		ClearDead();

		if (slice % 60 == 0) {
			printf(" %0.1fh: [HT] %d, [KT] %d, [DC] %d\n", (float)timeindex/600.0, totalcells[CELL_H], totalcells[CELL_K], totalcells[CELL_D]);
			if (totalcellslost > 0)
				printf("  Avg grid time: %0.1fh\n", (float)totalgridtime/(float)(totalcellslost * 600));
			if (nummfp > 0)
				printf("  Mean Free Path: %0.1fum\n", mfpsum/nummfp);
		}
	
		return true;
	}
	return false;
}

void LNGrid::DrawGrid() {
//	static float direction = 0.0f;
//	int dir = (int)floor(direction) % 26;

	glPushMatrix();

	glDisable(GL_LIGHTING);
#ifdef DISPGRIDBOX
	glColor3f(0.5, 0.5, 0.5);
	glBegin(GL_LINES);
	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);

	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);

	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f((float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, (float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, (float)LN_GRID_Z/2.0-0.5);
	glVertex3f(-(float)LN_GRID_X/2.0-0.5, -(float)LN_GRID_Y/2.0-0.5, -(float)LN_GRID_Z/2.0-0.5);
	glEnd();
#endif

	if (ENABLE_OUTLINE) {
		glColor3f(0.3, 0.3, 0.3);
		// now draw new grid boundaries
		glBegin(GL_LINES);
#ifdef DISPGRIDZ
		// iterate through x with y > LN_GRID_Y/2 and y < LN_GRID_Y/2 and find min y
		for (int z = 0; z < LN_GRID_Z; z++) {
			for (int x = 0; x < LN_GRID_X; x++) {
				int y1 = LN_GRID_Y - 1;
				for (int y = LN_GRID_Y/2; y < LN_GRID_Y; y++) {
					if (grid[x][y][z].cell.celltype == GRID_NOGO) {
						y1 = y;
						break;
					}
				}
				if (x != 0)
					glVertex3f(x-LN_GRID_X/2,y1-LN_GRID_Y/2,z-LN_GRID_Z/2);
				glVertex3f(x-LN_GRID_X/2,y1-LN_GRID_Y/2,z-LN_GRID_Z/2);
			}
			for (int x = LN_GRID_X - 1; x >= 0; x--) {
				int y2 = 0;
				for (int y = LN_GRID_Y/2; y >= 0; y--) {
					if (grid[x][y][z].cell.celltype == GRID_NOGO) {
						y2 = y;
						break;
					}
				}
				if (x != 0)
					glVertex3f(x-LN_GRID_X/2,y2-LN_GRID_Y/2,z-LN_GRID_Z/2);
				glVertex3f(x-LN_GRID_X/2,y2-LN_GRID_Y/2,z-LN_GRID_Z/2);
			}
		}
#endif

#ifdef DISPGRIDY
		// now iterate through x with z > LN_GRID_Z/2 and z < LN_GRID_Z/2 and find min z
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int x = 0; x < LN_GRID_X; x++) {
				int z1 = LN_GRID_Z - 1;
				for (int z = LN_GRID_Z/2; z < LN_GRID_Z; z++) {
					if (grid[x][y][z].cell.celltype == GRID_NOGO) {
						z1 = z;
						break;
					}
				}
				if (x != 0)
					glVertex3f(x-LN_GRID_X/2,y-LN_GRID_Y/2,z1-LN_GRID_Z/2);
				glVertex3f(x-LN_GRID_X/2,y-LN_GRID_Y/2,z1-LN_GRID_Z/2);
			}
			for (int x = LN_GRID_X - 1; x >= 0; x--) {
				int z2 = 0;
				for (int z = LN_GRID_Z/2; z >= 0; z--) {
					if (grid[x][y][z].cell.celltype == GRID_NOGO) {
						z2 = z;
						break;
					}
				}
				if (x != 0)
					glVertex3f(x-LN_GRID_X/2,y-LN_GRID_Y/2,z2-LN_GRID_Z/2);
				glVertex3f(x-LN_GRID_X/2,y-LN_GRID_Y/2,z2-LN_GRID_Z/2);
			}
		}
#endif

		glEnd();
	}

#ifndef SHOWALLCELLS
#ifdef DRAWPOINTS
	glBegin(GL_POINTS);
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				if (!grid[x][y][z].cell.displaybig && grid[x][y][z].cell.celltype != CELL_NONE
						&& grid[x][y][z].cell.celltype != GRID_NOGO
						&& grid[x][y][z].cell.celltype != GRID_FRC) {
					if (grid[x][y][z].cell.celltype == CELL_K)
						glColor3f(0.5f, 0, 0);
					else if (grid[x][y][z].cell.celltype == CELL_H)
						glColor3f(0, 0, 0.5f);
			//		else if (grid[x][y][z].cell.celltype == GRID_FRC)
			//			glColor3f(1.0f, 1.0f, 1.0f);
				//	else if (grid[x][y][z].cell.celltype == CELL_D)
				//		glColor3f(0, 1.0f, 0);
				//	else if (grid[x][y][z].cell.celltype == GRID_NOGO)
				//		glColor3f(1.0, 1.0, 1.0);
	//				glColor4f(0.0f,1.0f,0.0f,0.5f);
					// these are infinitely small so allow +-0.5 unit
					float xrand = 0, yrand = 0, zrand = 0;
			//		if (grid[x][y][z].cell.celltype != GRID_FRC) {
						xrand = rnd.getfloat() - 0.5f;
						yrand = rnd.getfloat() - 0.5f;
						zrand = rnd.getfloat() - 0.5f;
			//		}
					glVertex3f(x - LN_GRID_X/2 + xrand, y - LN_GRID_Y/2 + yrand, z - LN_GRID_Z/2 + zrand);
				}
			}
		}
	}
	glEnd();
#endif
#endif

	if (ENABLE_FRC) {
		// draw FRC
		glColor3f(1.0, 1.0, 1.0);
		glBegin(GL_LINES);
		for (int x = 1; x < LN_GRID_X-1; x++) {
			for (int y = 1; y < LN_GRID_Y-1; y++) {
				for (int z = 1; z < LN_GRID_Z-1; z++) {
					if (grid[x][y][z].cell.celltype == GRID_FRC) {
						for (int x1 = -1; x1 <= 1; x1++) {
							for (int y1 = -1; y1 <= 1; y1++) {
								for (int z1 = -1; z1 <= 1; z1++) {
									if (grid[x+x1][y+y1][z+z1].cell.celltype == GRID_FRC) {
										glVertex3f(x - LN_GRID_X/2,y - LN_GRID_Y/2,z - LN_GRID_Z/2);
										glVertex3f(x+x1 - LN_GRID_X/2,y+y1 - LN_GRID_Y/2,z+z1 - LN_GRID_Z/2);
									}
								}
							}
						}
					}
				}
			}
		}
		glEnd();
	}

	glEnable(GL_LIGHTING);
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
#ifndef SHOWALLCELLS
				if (grid[x][y][z].cell.displaybig && grid[x][y][z].cell.celltype != CELL_NONE && grid[x][y][z].cell.celltype != GRID_NOGO) {
#else
				if (grid[x][y][z].cell.celltype != LCELL_NONE && grid[x][y][z].cell.celltype != LCELL_NOGO) {
#endif
					glPushMatrix();
					if (grid[x][y][z].cell.celltype == CELL_K) {
						if (grid[x][y][z].cell.state == KCELL_ACTIVE)
							glColor3f(0.2f, 0.4f, 1.0f); // light blue
						//	glColor3f(1.0f, 0.2f, 0.2f); // 0.4
						//	glColor3f(1.0f, 0.2f, 0.6f);
						else if (grid[x][y][z].cell.state == KCELL_EFFECTOR)
							glColor3f(0.2f, 1.0f, 0.6f); // aqua
						//	glColor3f(1.0f, 0.2f, 1.0f);
						//	glColor3f(1.0f, 0.2f, 0.88f);
						else
							glColor3f(0.0f, 0.0f, 1.0f); // blue // 0, .2, 1
						//	glColor3f(1.0f, 0.0f, 0.0f);
						//	glColor3f(1.0f, 0.2f, 0.2f);
					} else if (grid[x][y][z].cell.celltype == CELL_H) {
						if (grid[x][y][z].cell.state == HCELL_ACTIVE)
							glColor3f(1.0f, 0.2f, 0.2f); // light red
						//	glColor3f(0.2f, 0.4f, 1.0f);
						else if (grid[x][y][z].cell.state == HCELL_EFFECTOR)
							glColor3f(1.0f, 0.2f, 1.0f); // purple
						//	glColor3f(0.2f, 1.0f, 0.6f);
						//	glColor3f(0.0f, 1.0f, 1.0f);
						else
							glColor3f(1.0f, 0.0f, 0.0f); // light red
						//	glColor3f(0.0f, 0.0f, 1.0f); // 0, .2, 1
					} else if (grid[x][y][z].cell.celltype == CELL_D) {
						if (grid[x][y][z].cell.state == DCELL_IMMATURE)
							glColor3f(0.0f, 1.0f, 0.0f); // green
						//	glColor3f(0.2f, 1.0f, 0.2f);
						else if (grid[x][y][z].cell.state == DCELL_MATURE)
							glColor3f(0.4f, 1.0f, 0.4f); // light green
						else if (grid[x][y][z].cell.state == DCELL_LICENSED)  // LICENSED
							glColor3f(1.0f, 1.0f, 1.0f); // white
					//	else
					//		glColor3f(0.0f, 0.0f, 0.0f);
					} else if (grid[x][y][z].cell.celltype == OUTPUT_EFFERENT)
						glColor3f(1.0f, 1.0f, 0.0f); // yellow
					else if (grid[x][y][z].cell.celltype == INPUT_AFFERENT)
						glColor3f(1.0f, 0.4f, 0.4f); // pink
					//	glColor3f(1.0f, 0.0f, 1.0f);
					else if (grid[x][y][z].cell.celltype == INPUT_HEV)
						glColor3f(1.0f, 0.4f, 0.0f); // orange
					//	glColor3f(0.0f, 1.0f, 1.0f);
					float specReflection[] = { 1.0f, 1.0f, 1.0f, 1.0f };
					glMaterialfv(GL_FRONT_AND_BACK, GL_SPECULAR, specReflection);
					glMateriali(GL_FRONT_AND_BACK, GL_SHININESS, 200);

					// since the spheres are 0.35 radius = 0.7 diameter, they can budge by +- 0.15 in each axis
					// generate some offset values
					float xrand, yrand, zrand;
					#ifndef SHOWALLCELLS
						xrand = yrand = zrand = 0;
					#else
						if (domove == 0 || domove == 1) {
							xrand = yrand = zrand = 0;
						} else {
							xrand = getrand() / 2.5f - 0.2f;
							yrand = getrand() / 2.5f - 0.2f;
							zrand = getrand() / 2.5f - 0.2f;
						}
					#endif

					glTranslatef(x - LN_GRID_X/2 + xrand, y - LN_GRID_Y/2 + yrand, z - LN_GRID_Z/2 + zrand);
					if (grid[x][y][z].cell.celltype == CELL_D)
						glTranslatef(0.5, 0.5, 0.5);
					glPushMatrix();
					if (grid[x][y][z].cell.celltype == CELL_H || grid[x][y][z].cell.celltype == CELL_K || grid[x][y][z].cell.celltype == CELL_D)
						glRotatef(directions3[grid[x][y][z].cell.lastdir][0],directions3[grid[x][y][z].cell.lastdir][1],
							directions3[grid[x][y][z].cell.lastdir][2],directions3[grid[x][y][z].cell.lastdir][3]);
					//glRotatef(theta, 0, 1, 0); // for spinning
					if (grid[x][y][z].cell.celltype == CELL_D) {
					//	glScalef(1.0f, 2.0f, 1.0f);
						glCallList(mysphereIDbig);
					} else if (grid[x][y][z].cell.celltype == OUTPUT_EFFERENT || grid[x][y][z].cell.celltype == INPUT_AFFERENT || grid[x][y][z].cell.celltype == INPUT_HEV) {
						glCallList(mycylID);
					} else {
					//	glScalef(1.0f, 2.0f, 1.0f);
						glCallList(mysphereID);
					}
					glPopMatrix();

					glPopMatrix();
				}
			}
		}
	}

	glPopMatrix();

//	glPushMatrix();
	//glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glDisable(GL_LIGHTING);
	glLoadIdentity();
	glTranslatef(0.0f, 0.0f, -1.0f);
	// now draw text
	glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
	// Position The Text On The Screen
	glRasterPos2f(0.46, 0.38);

// Disable Windows specifc code, while trying to get the code to run under Linux.
#ifdef CLOCK
 	glPrint("%0.1fh", (float)timeindex/600.0f);	// Print GL Text To The Screen
#endif

	glEnable(GL_LIGHTING);

/*	//SDL_Surface *drawtext(TTF_Font *fonttodraw, char fgR, char fgG, char fgB, char fgA, 
	//char bgR, char bgG, char bgB, char bgA, char * text, textquality quality);
	fontsurface = drawtext(timerfont, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, "HELLO", solid);
//	timeindex
	//SDL_BlitSurface(fontsurface,0,screen,0);
	while ( SDL_BlitSurface(fontsurface, 0, screen, 0) == -2 ) {
		while ( SDL_LockSurface(fontsurface) < 0 )
			SDL_Delay(10);
		SDL_BlitSurface(fontsurface, 0, screen, 0);
		SDL_UnlockSurface(fontsurface);
    }*/
//	glPopMatrix();
}

void LNGrid::Recruitment() {
	// recruit
	int newht = 0, newkt = 0, newdc = 0;
	for (int i = 0; i < hevs.size(); i++) {
		if (rnd.getfloat() < P_PROB_H_RECRUITMENT) {
			coord temp = hevs[i];
			int newdir = rnd.get32() % 27;
			coord newcoord = applydir(temp, newdir);
			
			if (grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype == CELL_NONE) {
				grid[newcoord.x][newcoord.y][newcoord.z].cell.displaybig = (rnd.getfloat() > 0.998) ? 1 : 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.lastdir = newdir;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype = CELL_H;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.enter_time = timeindex;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.mfp = MFP_UNIT;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.movedyet = true;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time = timeindex - rnd.get_inrange(CD4_MIN_AGE, CD4_MAX_AGE);
				grid[newcoord.x][newcoord.y][newcoord.z].cell.death_time = grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time + rnd.getnormal(CD4_MAX_AGE, CD4_MAX_AGE_STD);
				grid[newcoord.x][newcoord.y][newcoord.z].cell.state = HCELL_RESTING;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.next_state = HCELL_RESTING;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.cognate = (rnd.get_inrange(1, 300) == 1) ? true : false;
			//	grid[newcoord.x][newcoord.y][newcoord.z].cell.dc_bound = false;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.dc_bound_time = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.division_counter = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.priming_history = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.hide_time = 0;
				totalcells[CELL_H]++;
				newht++;
			}
		}
		if (rnd.getfloat() < P_PROB_K_RECRUITMENT) {
			coord temp = hevs[i];
			int newdir = rnd.get32() % 27;
			coord newcoord = applydir(temp, newdir);
			
			if (grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype == CELL_NONE) {
				grid[newcoord.x][newcoord.y][newcoord.z].cell.displaybig = (rnd.getfloat() > 0.998) ? 1 : 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.lastdir = newdir;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype = CELL_K;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.enter_time = timeindex;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.mfp = MFP_UNIT;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.movedyet = true;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time = timeindex - rnd.get_inrange(CD8_MIN_AGE, CD8_MAX_AGE);
				grid[newcoord.x][newcoord.y][newcoord.z].cell.death_time = grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time + rnd.getnormal(CD8_MAX_AGE, CD8_MAX_AGE_STD);
				grid[newcoord.x][newcoord.y][newcoord.z].cell.state = KCELL_RESTING;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.next_state = KCELL_RESTING;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.cognate = (rnd.get_inrange(1, 300) == 1) ? true : false;
			//	grid[newcoord.x][newcoord.y][newcoord.z].cell.dc_bound = false;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.dc_bound_time = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.division_counter = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.priming_history = 0;
				grid[newcoord.x][newcoord.y][newcoord.z].cell.hide_time = 0;
				totalcells[CELL_K]++;
				newkt++;
			}
		}
	}
	if (timeindex % 12 == 0) {
		for (int i = 0; i < als.size(); i++) {
			if (rnd.getfloat() < P_PROB_D_RECRUITMENT) {
				coord temp = als[i];
				int newdir = rnd.get32() % 27;
				coord newcoord = applydir(temp, newdir);
				
				if (grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype == CELL_NONE) {
					grid[newcoord.x][newcoord.y][newcoord.z].cell.displaybig = 1;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.lastdir = newdir;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype = CELL_D;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.enter_time = timeindex;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.mfp = MFP_UNIT;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.movedyet = true;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time = timeindex - rnd.get_inrange(DC_MIN_AGE, DC_MAX_AGE);
					grid[newcoord.x][newcoord.y][newcoord.z].cell.death_time = grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time + rnd.getnormal(DC_MAX_AGE, DC_MAX_AGE_STD);
	//				grid[newcoord.x][newcoord.y][newcoord.z].cell.license_time = 0;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.hide_time = 0;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.lockdown = 0;
					grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC = rnd.getfloat() * 100.0f;
					if (grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC <= 40.0f)
						grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC = rnd.getnormal(50, 50);
					else
						grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC = rnd.getnormal(200, 50); // 250, 50?
					if (grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC < 0.0f)
						grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC = 0.0f;
					if (grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC > pMHC_LIMIT)
						grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC = pMHC_LIMIT;
					if (grid[newcoord.x][newcoord.y][newcoord.z].cell.pMHC <= IDC_MDC_BOUNDARY) {
						grid[newcoord.x][newcoord.y][newcoord.z].cell.state = DCELL_IMMATURE;
						grid[newcoord.x][newcoord.y][newcoord.z].cell.next_state = DCELL_IMMATURE;
					} else {
						grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time = timeindex - rnd.getnormal(20, 5) * HOUR;
						grid[newcoord.x][newcoord.y][newcoord.z].cell.death_time = grid[newcoord.x][newcoord.y][newcoord.z].cell.birth_time + rnd.getnormal(DC_MAX_TIME_MATURE, DC_MAX_TIME_MATURE_STD);
						grid[newcoord.x][newcoord.y][newcoord.z].cell.state = DCELL_MATURE;
						grid[newcoord.x][newcoord.y][newcoord.z].cell.next_state = DCELL_MATURE;
					}

					totalcells[CELL_D]++;
					newdc++;
				}
			}
		}
	}
	printf("New HT: %d, new KT: %d, new DC: %d\n", newht, newkt, newdc);
}

void LNGrid::Movement() {
	// MOVE CELLS
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				// generate direction and validate
				if (grid[x][y][z].cell.movedyet == false && grid[x][y][z].cell.celltype != CELL_NONE 
						&& grid[x][y][z].cell.celltype != GRID_NOGO && grid[x][y][z].cell.celltype != OUTPUT_EFFERENT 
						&& grid[x][y][z].cell.celltype != INPUT_AFFERENT && grid[x][y][z].cell.celltype != INPUT_HEV
						&& grid[x][y][z].cell.celltype != GRID_FRC && 
						!(grid[x][y][z].cell.celltype == CELL_H && grid[x][y][z].cell.state == HCELL_BOUND) &&
						!(grid[x][y][z].cell.celltype == CELL_K && grid[x][y][z].cell.state == KCELL_BOUND)) {
					if (grid[x][y][z].cell.celltype == CELL_D && timeindex % 12 != 0) // don't do DCs every cycle
						continue;
					int numdirs = getnumdirs(grid[x][y][z].cell.lastdir);
					int lastdir = grid[x][y][z].cell.lastdir;
					int newdir = rand() % numdirs;
					newdir = nearbydirs[grid[x][y][z].cell.lastdir][newdir];
					//newdir = 25; // *
					coord current;
					current.x = x;
					current.y = y;
					current.z = z;
					coord newcoord = applydir(current, newdir);
					//coord newcoord = applydir(current, grid[x][y][z].cell.lastdir);
					grid[x][y][z].cell.lastdir = newdir;
					grid[x][y][z].cell.movedyet = true;
					if (grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype == CELL_NONE) {
						grid[newcoord.x][newcoord.y][newcoord.z].cell = grid[x][y][z].cell;
						grid[x][y][z].cell.celltype = CELL_NONE; // remove old
						// did move, so increment
						if (newdir == lastdir) {
							grid[newcoord.x][newcoord.y][newcoord.z].cell.mfp += MFP_UNIT;
						} else { // save last mfp
							mfpsum += grid[x][y][z].cell.mfp;
							nummfp++;
							grid[newcoord.x][newcoord.y][newcoord.z].cell.mfp = MFP_UNIT;
						}
					} else if (grid[newcoord.x][newcoord.y][newcoord.z].cell.celltype == OUTPUT_EFFERENT) { // remove
						mfpsum += grid[x][y][z].cell.mfp; // save last mfp
						nummfp++;

						totalgridtime += timeindex - grid[x][y][z].cell.enter_time; // to figure out how long cells stay on the grid
						totalcellslost++;
						totalcells[grid[x][y][z].cell.celltype]--;
						if (totalcellslost >= 30000) {
							totalgridtime /= 2;
							totalcellslost /= 2;
						}
						grid[x][y][z].cell.celltype = CELL_NONE;
					} // if no movement maybe clear mfp?
				}
			}
		}
	}
}

void LNGrid::ClearMoved() {
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				if (grid[x][y][z].cell.celltype == CELL_H || grid[x][y][z].cell.celltype == CELL_K)
//					|| grid[x][y][z].cell.celltype == CELL_D)
					grid[x][y][z].cell.movedyet = false;
				if (grid[x][y][z].cell.celltype == CELL_D && grid[x][y][z].cell.lockdown == 0)
					grid[x][y][z].cell.movedyet = false;
			}
		}
	}
}

void LNGrid::States() {
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				grid[x][y][z].cell.next_state = grid[x][y][z].cell.state; // just in case

				if (grid[x][y][z].cell.celltype == CELL_H) {
					if (grid[x][y][z].cell.state == HCELL_RESTING) {
						coord location;
						if (grid[x][y][z].cell.hide_time && timeindex >= grid[x][y][z].cell.hide_time) {
							grid[x][y][z].cell.displaybig = (rnd.getfloat() > 0.998) ? 1 : 0;
							grid[x][y][z].cell.hide_time = 0;
						}
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = HCELL_DEAD;
						} else if (grid[x][y][z].cell.cognate && (InMooreState(coordc(x,y,z), CELL_D, DCELL_LICENSED, &location) || InMooreState(coordc(x,y,z), CELL_D, DCELL_MATURE, &location))) {
						//} else if (grid[x][y][z].cell.cognate && (InMooreStateRadius(coordc(x,y,z), CELL_D, DCELL_LICENSED, 2.0f, &location) || InMooreStateRadius(coordc(x,y,z), CELL_D, DCELL_MATURE, 2.0f, &location))) {
						//	if (grid[location.x][location.y][location.z].cell.state == DCELL_LICENSED || grid[location.x][location.y][location.z].cell.state == DCELL_MATURE) {
							float ap = CD4_pMHC_FOR_MEDIAN_BINDING_PROB;
							float bp = CD4_SHAPE_BINDING_PROB_CURVE;
							float xp = grid[location.x][location.y][location.z].cell.pMHC;
							float binding_probability = 100/(1+exp(-1*(xp-ap)/bp)); //100.0f / (1.0f + exp(-(grid[location.x][location.y][location.z].cell.pMHC-CD8_pMHC_FOR_MEDIAN_BINDING_PROB)/CD8_SHAPE_BINDING_PROB_CURVE));
							//float binding_probability = 100.0f / (1.0f + exp(-(grid[location.x][location.y][location.z].cell.pMHC-CD4_pMHC_FOR_MEDIAN_BINDING_PROB)/CD4_SHAPE_BINDING_PROB_CURVE));
							if (rnd.getfloat() * 100.0f <= binding_probability) {
							//	grid[x][y][z].cell.dc_bound = true;
								grid[x][y][z].cell.dc_bound_time = timeindex;
								grid[x][y][z].cell.dc_unbind_time = timeindex + rnd.getnormal(CD4_MAX_BINDING_TIME, CD4_MAX_BINDING_TIME_STD);
								grid[x][y][z].cell.dc_unbind_pMHC = UNBINDING_THRESHOLD + rnd.get_inrange(0, 50);
								grid[x][y][z].cell.dc_coord = location;
								grid[location.x][location.y][location.z].cell.lockdown = 1;
								grid[location.x][location.y][location.z].cell.movedyet = true;
								grid[x][y][z].cell.next_state = HCELL_BOUND;
								grid[x][y][z].cell.displaybig = 1; // ***
							}
						//	}
						}
					} else if (grid[x][y][z].cell.state == HCELL_BOUND) {
						coord location = grid[x][y][z].cell.dc_coord;
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = HCELL_DEAD;
						} else if (((timeindex - grid[x][y][z].cell.birth_time) % HOUR) == 0) {
							if (grid[location.x][location.y][location.z].cell.state != DCELL_DEAD && 
								grid[location.x][location.y][location.z].cell.celltype == CELL_D) {
							//	float pMHC_decay = pow((float)(exp(log(0.5) / (30.0f * pMHC_HALFLIFE))), (float)15.0f);
							//	grid[x][y][z].cell.priming_history += (grid[location.x][location.y][location.z].cell.pMHC / pMHC_decay);
							//	if (grid[x][y][z].cell.priming_history > PRIMING_THRESHOLD_VALUE || // ***
							//		grid[location.x][location.y][location.z].cell.pMHC < UNBINDING_THRESHOLD ||
							//		(timeindex - grid[x][y][z].cell.dc_bound_time) > CD4_MAX_BINDING_TIME) {
								if (grid[location.x][location.y][location.z].cell.pMHC < grid[x][y][z].cell.dc_unbind_pMHC ||
									timeindex >= grid[x][y][z].cell.dc_unbind_time) {
									float cp = CD4_TIME_FOR_MEDIAN_PRIMING_PROB;
									float dp = CD4_SHAPE_PRIMING_PROB_CURVE;
									float xp = grid[location.x][location.y][location.z].cell.pMHC * (timeindex - grid[x][y][z].cell.dc_bound_time);
								//	grid[x][y][z].cell.dc_bound = false;
									float priming_probability = 100.0f/(1+exp(-1*(xp-cp)/dp)); //90.0f;// 100.0f / (exp(-(grid[x][y][z].cell.priming_history / UNBINDING_THRESHOLD - CD4_TIME_FOR_MEDIAN_PRIMING_PROB)/CD4_SHAPE_PRIMING_PROB_CURVE));
									//cout << "H cell priming probability: " << priming_probability << endl;
									if (rnd.getfloat() * 100.0f <= priming_probability) {
										grid[x][y][z].cell.birth_time = timeindex;
										grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD4_MAX_AGE, CD4_MAX_AGE_STD);
									//	grid[x][y][z].cell.dc_bound = false;
										grid[x][y][z].cell.displaybig = 1; // ***
										grid[x][y][z].cell.next_state = HCELL_ACTIVE;
										grid[x][y][z].cell.division_counter = 0;
									} else {
										grid[x][y][z].cell.next_state = HCELL_RESTING;
										grid[x][y][z].cell.hide_time = timeindex + HOUR;
										grid[x][y][z].cell.priming_history = 0.0f;
									}
								}
							} else {
								grid[x][y][z].cell.hide_time = timeindex + HOUR;
								grid[x][y][z].cell.next_state = HCELL_RESTING;
								grid[x][y][z].cell.priming_history = 0.0f;
							}
						}
					} else if (grid[x][y][z].cell.state == HCELL_ACTIVE) {
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = HCELL_DEAD;
						} else if (grid[x][y][z].cell.division_counter >= CD4_MAX_DIVISION) {
							grid[x][y][z].cell.birth_time = timeindex;
							grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD4_MAX_TIME_EFFECTOR, CD4_MAX_TIME_EFFECTOR_STD);
							grid[x][y][z].cell.displaybig = 1; // ***
							grid[x][y][z].cell.next_state = HCELL_EFFECTOR;
						} else if ((timeindex - grid[x][y][z].cell.birth_time) >= CD4_DOUBLING_PERIOD) {
							coord location;
							if (InMoore(coordc(x,y,z), CELL_NONE, &location)) {
								grid[x][y][z].cell.birth_time = timeindex;
								grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD4_MAX_AGE, CD4_MAX_AGE_STD);
								grid[x][y][z].cell.division_counter++;
								
								// now proliferate into location
								grid[location.x][location.y][location.z].cell = grid[x][y][z].cell;
								//grid[location.x][location.y][location.z].cell.birth_time = timeindex;
								grid[location.x][location.y][location.z].cell.death_time = timeindex + rnd.getnormal(CD4_MAX_AGE, CD4_MAX_AGE_STD);
								grid[location.x][location.y][location.z].cell.enter_time = timeindex;
								grid[location.x][location.y][location.z].cell.mfp = MFP_UNIT;
								//grid[location.x][location.y][location.z].cell.dc_bound = false;
								//grid[location.x][location.y][location.z].cell.dc_bound_time = 0.0f;
								grid[location.x][location.y][location.z].cell.priming_history = 0.0f;
							}
						}
					} else if (grid[x][y][z].cell.state == HCELL_EFFECTOR) {
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = HCELL_DEAD;
						}
					}
				} else if (grid[x][y][z].cell.celltype == CELL_K) {
					if (grid[x][y][z].cell.state == KCELL_RESTING) {
						coord location;
						if (grid[x][y][z].cell.hide_time && timeindex >= grid[x][y][z].cell.hide_time) {
							grid[x][y][z].cell.displaybig = (rnd.getfloat() > 0.998) ? 1 : 0;
							grid[x][y][z].cell.hide_time = 0;
						}
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = KCELL_DEAD;
						} else if (grid[x][y][z].cell.cognate && InMooreState(coordc(x,y,z), CELL_D, DCELL_LICENSED, &location)) {
						//} else if (grid[x][y][z].cell.cognate && InMooreStateRadius(coordc(x,y,z), CELL_D, DCELL_LICENSED, 2.0f, &location)) {
						//	if (grid[location.x][location.y][location.z].cell.state == DCELL_LICENSED) {	
							float ap = CD8_pMHC_FOR_MEDIAN_BINDING_PROB;
							float bp = CD8_SHAPE_BINDING_PROB_CURVE;
							float xp = grid[location.x][location.y][location.z].cell.pMHC;
							float binding_probability = 100/(1+exp(-1*(xp-ap)/bp)); //100.0f / (1.0f + exp(-(grid[location.x][location.y][location.z].cell.pMHC-CD8_pMHC_FOR_MEDIAN_BINDING_PROB)/CD8_SHAPE_BINDING_PROB_CURVE));
							if (rnd.getfloat() * 100.0f <= binding_probability) {
							//	grid[x][y][z].cell.dc_bound = true;
								grid[x][y][z].cell.dc_bound_time = timeindex;
								grid[x][y][z].cell.dc_unbind_time = timeindex + rnd.getnormal(CD8_MAX_BINDING_TIME, CD8_MAX_BINDING_TIME_STD);
								grid[x][y][z].cell.dc_unbind_pMHC = UNBINDING_THRESHOLD + rnd.get_inrange(0, 50);
								grid[x][y][z].cell.dc_coord = location;
								grid[location.x][location.y][location.z].cell.lockdown = 1;
								grid[location.x][location.y][location.z].cell.movedyet = true;
								grid[x][y][z].cell.next_state = KCELL_BOUND;
								grid[x][y][z].cell.displaybig = 1; // ***
							}
						//	}
						}
					} else if (grid[x][y][z].cell.state == KCELL_BOUND) {
						coord location = grid[x][y][z].cell.dc_coord;
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = KCELL_DEAD;
						} else if (((timeindex - grid[x][y][z].cell.birth_time) % HOUR) == 0) {
							if (grid[location.x][location.y][location.z].cell.state != DCELL_DEAD && 
								grid[location.x][location.y][location.z].cell.celltype == CELL_D) {
								//float pMHC_decay = pow((float)(exp(log(0.5) / (30.0f * pMHC_HALFLIFE))), (float)15.0f);
								//grid[x][y][z].cell.priming_history += (grid[location.x][location.y][location.z].cell.pMHC / pMHC_decay);
								//if (grid[x][y][z].cell.priming_history > PRIMING_THRESHOLD_VALUE ||
								//	grid[location.x][location.y][location.z].cell.pMHC < UNBINDING_THRESHOLD ||
								//	(timeindex - grid[x][y][z].cell.dc_bound_time) > CD8_MAX_BINDING_TIME) {
								if (grid[location.x][location.y][location.z].cell.pMHC < grid[x][y][z].cell.dc_unbind_pMHC ||
									timeindex >= grid[x][y][z].cell.dc_unbind_time) {
									//	grid[x][y][z].cell.dc_bound = false;
									float cp = CD8_TIME_FOR_MEDIAN_PRIMING_PROB;
									float dp = CD8_SHAPE_PRIMING_PROB_CURVE;
									float xp = grid[location.x][location.y][location.z].cell.pMHC * (timeindex - grid[x][y][z].cell.dc_bound_time);
									float priming_probability = 100.0f/(1+exp(-1*(xp-cp)/dp)); //90.0f;//100.0f / (exp(-(grid[x][y][z].cell.priming_history / UNBINDING_THRESHOLD - CD8_TIME_FOR_MEDIAN_PRIMING_PROB)/CD8_SHAPE_PRIMING_PROB_CURVE));
									if (rnd.getfloat() * 100.0f <= priming_probability) {
										grid[x][y][z].cell.birth_time = timeindex;
										grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD8_MAX_AGE, CD8_MAX_AGE_STD);
								//		grid[x][y][z].cell.dc_bound = false;
										grid[x][y][z].cell.displaybig = 1; // ***
										grid[x][y][z].cell.next_state = KCELL_ACTIVE;
										grid[x][y][z].cell.division_counter = 0;
									} else {
										grid[x][y][z].cell.next_state = KCELL_RESTING;
										grid[x][y][z].cell.hide_time = timeindex + HOUR;
										grid[x][y][z].cell.priming_history = 0.0f;
									}
								}
							} else {
								grid[x][y][z].cell.next_state = KCELL_RESTING;
								grid[x][y][z].cell.hide_time = timeindex + HOUR;
								grid[x][y][z].cell.priming_history = 0.0f;
							}
						}
					} else if (grid[x][y][z].cell.state == KCELL_ACTIVE) {
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = KCELL_DEAD;
						} else if (grid[x][y][z].cell.division_counter >= CD8_MAX_DIVISION) {
							grid[x][y][z].cell.birth_time = timeindex;
							grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD8_MAX_TIME_EFFECTOR, CD8_MAX_TIME_EFFECTOR_STD);
							grid[x][y][z].cell.displaybig = 1; // ***
							grid[x][y][z].cell.next_state = KCELL_EFFECTOR;
						} else if ((timeindex - grid[x][y][z].cell.birth_time) >= CD8_DOUBLING_PERIOD) {
							coord location;
							if (InMoore(coordc(x,y,z), CELL_NONE, &location)) {
								grid[x][y][z].cell.birth_time = timeindex;
								grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(CD8_MAX_AGE, CD8_MAX_AGE_STD);
								grid[x][y][z].cell.division_counter++;
								
								// now proliferate into location
								grid[location.x][location.y][location.z].cell = grid[x][y][z].cell;
							//	grid[location.x][location.y][location.z].cell.birth_time = timeindex;
								grid[location.x][location.y][location.z].cell.death_time = timeindex + rnd.getnormal(CD8_MAX_AGE, CD8_MAX_AGE_STD);
								grid[location.x][location.y][location.z].cell.enter_time = timeindex;
								grid[location.x][location.y][location.z].cell.mfp = MFP_UNIT;
							//	grid[location.x][location.y][location.z].cell.dc_bound = false;
							//	grid[location.x][location.y][location.z].cell.dc_bound_time = 0.0f;
								grid[location.x][location.y][location.z].cell.priming_history = 0.0f;
							}
						}
					} else if (grid[x][y][z].cell.state == KCELL_EFFECTOR) {
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = KCELL_DEAD;
						}
					}
				} else if (grid[x][y][z].cell.celltype == CELL_D && timeindex % 12 == 0) {
					if (grid[x][y][z].cell.state == DCELL_IMMATURE) {
						grid[x][y][z].cell.pMHC *= pMHC_DECAY_FACTOR;
						coord location;
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = DCELL_DEAD;
						} else if (InMooreState(coordc(x,y,z), CELL_D, DCELL_LICENSED, &location) || InMooreState(coordc(x,y,z), CELL_D, DCELL_MATURE, &location)) {
							grid[x][y][z].cell.birth_time = timeindex;
							grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(DC_MAX_TIME_MATURE, DC_MAX_TIME_MATURE_STD);
							grid[x][y][z].cell.pMHC += grid[location.x][location.y][location.z].cell.pMHC; //((BINDING_THRESHOLD) + grid[location.x][location.y][location.z].cell.pMHC / 2.0f);
							grid[x][y][z].cell.next_state = DCELL_MATURE;
						}
					} else if (grid[x][y][z].cell.state == DCELL_MATURE) {
						grid[x][y][z].cell.pMHC *= pMHC_DECAY_FACTOR;
						coord location;
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = DCELL_DEAD;
						} else if (InMooreState(coordc(x,y,z), CELL_H, HCELL_EFFECTOR, &location)) {
							if (rnd.getfloat() * 100.0f <= PROB_eHELPER_LICENSES_MDC) {
								grid[x][y][z].cell.birth_time = timeindex;
								grid[x][y][z].cell.death_time = timeindex + rnd.getnormal(DC_TIME_BEING_LICENSED, DC_TIME_BEING_LICENSED_STD);
								grid[x][y][z].cell.pMHC += 150;
							//	grid[x][y][z].cell.license_time = timeindex;
								grid[x][y][z].cell.next_state = DCELL_LICENSED;
							}
						}
					} else if (grid[x][y][z].cell.state == DCELL_LICENSED) {
						grid[x][y][z].cell.pMHC *= pMHC_DECAY_FACTOR;
						if (timeindex >= grid[x][y][z].cell.death_time) {
							grid[x][y][z].cell.next_state = DCELL_DEAD;
						}
					}
				}
			}
		}
	}
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				grid[x][y][z].cell.state = grid[x][y][z].cell.next_state; // implement
			}
		}
	}
}

void LNGrid::ClearDead() {
	for (int x = 0; x < LN_GRID_X; x++) {
		for (int y = 0; y < LN_GRID_Y; y++) {
			for (int z = 0; z < LN_GRID_Z; z++) {
				if ((grid[x][y][z].cell.celltype == CELL_H || 
					grid[x][y][z].cell.celltype == CELL_K || 
					grid[x][y][z].cell.celltype == CELL_D) && 
					grid[x][y][z].cell.state == CELL_DEAD) {
						// remove and possibly save some statistics
						grid[x][y][z].cell.celltype = CELL_NONE;
				}
			}
		}
	}
}

int LNGrid::FRC_generator(int num_iterations) {
	//FRC generation function version 1
	// cellstruct environment[][][] :the grid in which to build the FRC
	// int num_iterations :number of iterations to run...  "h < *"  Number is arbitrary

	int totalfrc = 0;	//initilize to zero to keep track of number of microcompartments with FRC		
	int i_size = LN_GRID_X;
	int j_size = LN_GRID_Y;
	int k_size = LN_GRID_Z;

	grid[1][j_size/2][k_size/2].cell.celltype = GRID_FRC;    //start with the center microcompartment as the "seed"
	totalfrc++;

	for (int h = 0; h < num_iterations; h++) {
		for (int i = 1; i < i_size - 1; i++) {    // do not calculate the microcompartments on the edge
			for (int j = 1; j < j_size - 1; j++) {
				for (int k = 1; k < k_size - 1; k++) {
					int surrounding = 0;	// Number of the surrounding microcompartments that contain an FRC tag
					//Check all 26 surrounding microcompartments to see their "FRC status"
					for (int i_adj = -1; i_adj <= 1; i_adj++) {
						for (int j_adj = -1; j_adj <= 1; j_adj++) {
							for (int k_adj = -1; k_adj <= 1; k_adj++) {
								if (grid[i+i_adj][j+j_adj][k+k_adj].cell.celltype == GRID_FRC)
									surrounding++;
							}
						}
					}
					if (grid[i][j][k].cell.celltype == GRID_FRC)
						surrounding--;	//correct error: current microcompartment being worked on does not 
								//count as a surrounding microcompartment.

					if (surrounding == 1) {
						int prob = rand() % 1000;
						if (prob <= 100 && grid[i][j][k].cell.celltype == CELL_NONE) {
							grid[i][j][k].cell.celltype = GRID_FRC;
							totalfrc++;
						}
					} else if (surrounding == 2) {
						int prob = rand() % 1000;
						if (prob <= 10 && grid[i][j][k].cell.celltype == CELL_NONE) {
							grid[i][j][k].cell.celltype = GRID_FRC;
							totalfrc++;
						}
					}
				}
			}
		}
	}

	return totalfrc;
}



bool LNGrid::InMoore(coordc currloc, CellTypes tofind, coord * loc) {
	// iterate through +- 1 cell in each direction, return when we find something
	int startx = currloc.x - 1;
	int endx = currloc.x + 1;
	int starty = currloc.y - 1;
	int endy = currloc.y + 1;
	int startz = currloc.z - 1;
	int endz = currloc.z + 1;

	if (startx < 0)
		startx = 0;
	if (starty < 0)
		starty = 0;
	if (startz < 0)
		startz = 0;
	if (endx >= LN_GRID_X)
		endx = LN_GRID_X - 1;
	if (endy >= LN_GRID_Y)
		endy = LN_GRID_Y - 1;
	if (endz >= LN_GRID_Z)
		endz = LN_GRID_Z - 1;

	for (int x = startx; x <= endx; x++) {
		for (int y = starty; y <= endy; y++) {
			for (int z = startz; z <= endz; z++) {
				if (grid[x][y][z].cell.celltype == tofind &&
					!(x == currloc.x && y == currloc.y && z == currloc.z)) {
					loc->x = x;
					loc->y = y;
					loc->z = z;
					return true;
				}
			}
		}
	}
	return false;
}

bool LNGrid::InMooreState(coordc currloc, CellTypes tofind, CellStates tomatch, coord * loc) {
	// iterate through +- 1 cell in each direction, return when we find something
	int startx = currloc.x - 1;
	int endx = currloc.x + 1;
	int starty = currloc.y - 1;
	int endy = currloc.y + 1;
	int startz = currloc.z - 1;
	int endz = currloc.z + 1;

	if (startx < 0)
		startx = 0;
	if (starty < 0)
		starty = 0;
	if (startz < 0)
		startz = 0;
	if (endx >= LN_GRID_X)
		endx = LN_GRID_X - 1;
	if (endy >= LN_GRID_Y)
		endy = LN_GRID_Y - 1;
	if (endz >= LN_GRID_Z)
		endz = LN_GRID_Z - 1;

	for (int x = startx; x <= endx; x++) {
		for (int y = starty; y <= endy; y++) {
			for (int z = startz; z <= endz; z++) {
				if (grid[x][y][z].cell.celltype == tofind && grid[x][y][z].cell.state == tomatch &&
					!(x == currloc.x && y == currloc.y && z == currloc.z)) {
					loc->x = x;
					loc->y = y;
					loc->z = z;
					return true;
				}
			}
		}
	}
	return false;
}

bool LNGrid::InMooreStateRadius(coordc currloc, CellTypes tofind, CellStates tomatch, float radius, coord * loc) {
	// iterate through +- 1 cell in each direction, return when we find something
	int radmax = ceil(radius);
	int startx = currloc.x - radmax;
	int endx = currloc.x + radmax;
	int starty = currloc.y - radmax;
	int endy = currloc.y + radmax;
	int startz = currloc.z - radmax;
	int endz = currloc.z + radmax;

	if (startx < 0)
		startx = 0;
	if (starty < 0)
		starty = 0;
	if (startz < 0)
		startz = 0;
	if (endx >= LN_GRID_X)
		endx = LN_GRID_X - 1;
	if (endy >= LN_GRID_Y)
		endy = LN_GRID_Y - 1;
	if (endz >= LN_GRID_Z)
		endz = LN_GRID_Z - 1;

	for (int x = startx; x <= endx; x++) {
		for (int y = starty; y <= endy; y++) {
			for (int z = startz; z <= endz; z++) {
				float dist = sqrt(pow((float)(x-currloc.x),2) + pow((float)(y-currloc.y),2) + pow((float)(z-currloc.z),2));
				if (dist <= radius && grid[x][y][z].cell.celltype == tofind && grid[x][y][z].cell.state == tomatch &&
					!(x == currloc.x && y == currloc.y && z == currloc.z)) {
					loc->x = x;
					loc->y = y;
					loc->z = z;
					return true;
				}
			}
		}
	}
	return false;
}

