#include "stdafx.h"

#ifndef __VIZ3D_H__
#define __VIZ3D_H__

#include "rand/types.h"
#include "urandom.h"

#include "critical_params.h"
#include "VizGrid.h"
extern urandom rnd;
/*enum CellTypes { CELL_NONE = 0, CELL_ALL = 0, CELL_H = 1, CELL_K = 2, CELL_D = 3,
	CELL_TG = 4, CELL_CD4 = 5, CELL_CD8 = 6, CELL_M = 7, // 8
	INPUT_HEV = 0, INPUT_AFFERENT = 1,
	OUTPUT_EFFERENT = 0};
#define NUMCELLTYPES	8
enum CytokineTypes { CK_TNF = 0, CK_CCL5, CK_CXCL9, CK_CCL2, CK_TOTAL};

// cell states
enum CellStates {
	CELL_DEAD = 0, CELL_COMPLETE = 0,

	HCELL_DEAD = 0, HCELL_RESTING = 1, HCELL_NOTMOVE_BY_DC = 2,
	HCELL_ACTIVE = 3, HCELL_EFFECTOR = 4, HCELL_BOUND_TO_IDC = 5,

	KCELL_DEAD = 0, KCELL_RESTING = 1, KCELL_NOTMOVE_BY_LDC = 2,
	KCELL_ACTIVE = 3, KCELL_EFFECTOR = 4, KCELL_MEMORY = 5,

	DCELL_DEAD = 0, DCELL_IMMATURE = 1, DCELL_MATURE = 2, DCELL_LICENSED = 3,

	// TB
	TGCELL_DEAD = 0, TGCELL_RESTING = 1, TGCELL_ACTIVE = 2, TGCELL_REG = 3,

	//	TCCELL_DEAD = 0, TCCELL_RESTING = 1, TCCELL_ACTIVE = 2,

	//	TRCELL_DEAD = 0, TRCELL_RESTING = 1, TRCELL_ACTIVE = 2,
	CD4CELL_DEAD = 0, CD4CELL_RESTING = 1, CD4CELL_ACTIVE = 2,
	CD8CELL_DEAD = 0, CD8CELL_RESTING = 1, CD8CELL_ACTIVE = 2,

	MCELL_DEAD = 0, MCELL_RESTING = 1, MCELL_INFECTED = 2, MCELL_CINFECTED = 3,
	MCELL_ACTIVE = 4
};*/

enum OutputMode { MODE_CELL = 0, MODE_INPUT, MODE_OUTPUT, MODE_CHECKPOINT };

#ifdef WIN32
#pragma pack(push, 1)
#endif
/*
#if (GRANULOMA == 1)
#define GRID_X	400
#define GRID_Y	400
#define GRID_Z	400
#else
// 400x50x40
#define GRID_X	400
#define GRID_Y	50
#define GRID_Z	40
// 40 or 1
#endif
*/

#define P_PROB_H_RECRUITMENT	99
#define P_PROB_K_RECRUITMENT	95
#define P_PROB_D_RECRUITMENT	1
// was 99 & 95

enum types {LCELL_NONE = 0, LCELL_HT, LCELL_KT, LCELL_D, LCELL_NOGO, LCELL_AL, LCELL_EL, LCELL_HEV, LCELL_FRC, LCELL_TOTAL};
struct cellstruct {
	types celltype;
	bool displaybig;
	bool movedyet;
	int lastdir;
	int createtime;
};

//struct coord {
//	int x, y, z;
//};

class GridCoord { // 3 bytes
	public:
		GridCoord() {x = 0; y = 0; z = 0;}
		GridCoord(u16 a, u16 b, u16 c){x = a; y = b; z = c;}

#ifdef WIN32
		u32 x:10; // 10 bits = 1024
		u32 y:7; // 7 bits = 128
		u32 z:7; // 7 bits = 128
#else
		u16 x:10; // 10 bits = 1024
		u16 y:7; // 7 bits = 128
		u16 z:7; // 7 bits = 128
#endif

		inline u8 isal(); // finds conflicts
		inline u8 ishev();
		inline u8 isel();
		bool isequal(GridCoord gc) {return (gc.x == x && gc.y == y && gc.z == z);}
		int getmovecoord(int currsc, u8 & dir);
#ifdef WIN32
};
#else
} __attribute__ ((packed));
#endif

struct OutStruct {
#ifdef WIN32
	u32 x:9; // 9 bits = 512
	u32 y:6; // 6 bits = 64
	u32 z:6; // 6 bits = 64
	u32 s:3; // 3 bits = 8 (slot)
	u32 type:3; // 3 bits = 8 types
	u32 state:3; // 3 bits = 8 states
	u32 mode:2; // 0 = set coordinates, 1 = set afferent/hev, 2 = set efferent, 3 = frame checkpoint
#else
	u16 x:9; // 9 bits = 512
	u16 y:6; // 6 bits = 64
	u16 z:6; // 6 bits = 64
	u16 s:3; // 3 bits = 8 (slot)
	CellTypes type:3; // 3 bits = 8 types
	CellStates state:3; // 3 bits = 8 states
	OutputMode mode:2; // 0 = set coordinates, 1 = set afferent/hev, 2 = set efferent, 3 = frame checkpoint
#endif
	// at 32 bits
#ifdef WIN32
};
#else
} __attribute__ ((packed));
#endif // 4 bytes per record

struct CompareStruct {
#ifdef WIN32
	u8 type:3;
	u8 state:3;
	u8 mode:2;
#else
	CellTypes type:3;
	CellStates state:3;
	OutputMode mode:2;
#endif
	// at 8 bits
#ifdef WIN32
};
#else
} __attribute__ ((packed));
#endif // 1 byte per record

const coord dirdelta[26] = {
	{-1, 1, 1}, // 0
	{ 0, 1, 1}, // 1
	{ 1, 1, 1}, // 2
	{ 1, 0, 1}, // 3
	{ 0, 0, 1}, // 4
	{-1, 0, 1}, // 5
	{-1,-1, 1}, // 6
	{ 0,-1, 1}, // 7
	{ 1,-1, 1}, // 8

	{-1, 1, 0}, // 9
	{ 0, 1, 0}, // 10
	{ 1, 1, 0}, // 11
	{ 1, 0, 0}, // 12
//	{ 0, 0, 0}, // 12
	{-1, 0, 0}, // 13
	{-1,-1, 0}, // 14
	{ 0,-1, 0}, // 15
	{ 1,-1, 0}, // 16

	{-1, 1, -1},  // 17
	{ 0, 1, -1}, // 18
	{ 1, 1, -1}, // 19
	{ 1, 0, -1}, // 20
	{ 0, 0, -1}, // 21
	{-1, 0, -1}, // 22
	{-1,-1, -1}, // 23
	{ 0,-1, -1}, // 24
	{ 1,-1, -1}, // 25
};

const unsigned char nearbydirs[][10] = {
	{0,1,4,5,9,10,13,77}, // 7
	{1,0,2,5,4,3,9,10,11,77}, // 9
	{2,1,3,4,10,11,12,77}, // 7
	{3,2,8,1,4,7,11,12,16,77}, // 9
	{4,3,5,0,1,2,6,7,8,77}, // 9
	{5,0,6,1,4,7,9,13,14,77}, // 9
	{6,5,4,7,13,14,15,77}, // 7
	{7,6,8,5,4,3,14,15,16,77}, // 9
	{8,4,3,7,12,15,16,77}, // 7
	{9,10,13,0,1,5,17,18,22,77}, // 9
	{10,9,11,0,1,2,17,18,19,77}, // 9
	{11,10,12,1,2,3,18,19,20,77}, // 9
	{12,11,16,2,3,8,19,20,25,77}, // 9
	{13,9,14,0,5,6,17,22,23,77}, // 9
	{14,13,15,5,6,7,22,23,24,77}, // 9
	{15,14,16,6,7,8,23,24,25,77}, // 9
	{16,12,15,3,7,8,20,24,25,77}, // 9
	{17,18,22,21,9,10,13,77}, // 7
	{18,17,19,20,21,20,9,10,11,77}, // 9
	{19,18,20,21,10,11,12,77}, // 7
	{20,19,25,18,21,24,11,12,16,77}, // 9
	{21,22,20,17,18,19,23,24,25,77}, // 9
	{22,17,23,18,21,24,9,13,14,77}, // 9
	{23,22,21,24,13,14,15,77}, // 7
	{24,23,25,22,21,20,14,15,16,77}, // 9
	{25,21,20,24,12,15,16,77} // 7
};

// Up:  0  1  2
//      5  4  3
//      6  7  8
// Md:  9 10 11
//     13    12
//     14 15 16
// Dn: 17 18 19
//     22 21 20
//     23 24 25

// Direction definitions
const float directions3[][4] = {
	// origin = front left
// x ->
// y ^
// z = up
// Up:  0  1  2
//      5  4  3
//      6  7  8
	{45.0f, 1.0f, 0.0f, 1.0f}, // 0 (good)
	{45.0f, 1.0f, 0.0f, 0.0f}, // 1 (good)
	{45.0f, 1.0f, 0.0f, -1.0f}, // 2 (good)
	{90.0f, 1.0f, 0.0f, -1.0f}, // 3 (good)
	{90.0f, 1.0f, 0.0f, 0.0f}, // 4 (good)
	{90.0f, 1.0f, 0.0f, 1.0f}, // 5 (good)
	{135.0f, 1.0f, 0.0f, 1.0f}, // 6 (good)
	{135.0f, 1.0f, 0.0f, 0.0f}, // 7 (good)
	{135.0f, 1.0f, 0.0f, -1.0f}, // 8 (good)

// Md:  9 10 11
//     13    12
//     14 15 16
	{45.0f, 0.0f, 0.0f, 1.0f}, // 9 (good)
	{0.0f, 0.0f, 0.0f, 0.0f}, // 10 (good)
	{45.0f, 0.0f, 0.0f, -1.0f}, // 11 (good)
	{90.0f, 0.0f, 0.0f, -1.0f}, // 12 (good)
	{90.0f, 0.0f, 0.0f, 1.0f}, // 13 (good)
	{135.0f, 0.0f, 0.0f, 1.0f}, // 14 (good)
	{135.0f, 0.0f, 0.0f, 0.0f}, // 15 (good)
	{135.0f, 0.0f, 0.0f, -1.0f}, // 16 (good)

// Dn: 17 18 19
//     22 21 20
//     23 24 25
	{45.0f, -1.0f, 0.0f, 1.0f}, // 17 (good)
	{45.0f, -1.0f, 0.0f, 0.0f}, // 18 (good)
	{45.0f, -1.0f, 0.0f, -1.0f}, // 19 (good)
	{90.0f, -1.0f, 0.0f, -1.0f}, // 20 (good)
	{90.0f, -1.0f, 0.0f, 0.0f}, // 21 (good)
	{90.0f, -1.0f, 0.0f, 1.0f}, // 22 (good)
	{135.0f, -1.0f, 0.0f, 1.0f}, // 23 (good)
	{135.0f, -1.0f, 0.0f, 0.0f}, // 24 (good)
	{135.0f, -1.0f, 0.0f, -1.0f}, // 25 (good)
};

int FRC_generator(int num_iterations);

#ifdef WIN32
#pragma pack(pop)
#endif

#endif
