#include "stdafx.h"

/*TTF_Font* loadfont(char* file, int ptsize) {
  TTF_Font* tmpfont;
  tmpfont = TTF_OpenFont(file, ptsize);
  if (tmpfont == NULL){
    printf("Unable to load font: %s %s \n", file, TTF_GetError());
    exit(1);
  }
  return tmpfont;
}
 
SDL_Surface *drawtext(TTF_Font *fonttodraw, char fgR, char fgG, char fgB, char fgA, 
	char bgR, char bgG, char bgB, char bgA, char * text, textquality quality) {
	SDL_Color tmpfontcolor = {fgR,fgG,fgB,fgA};
	SDL_Color tmpfontbgcolor = {bgR, bgG, bgB, bgA};
	SDL_Surface *resulting_text;
	
	if (quality == solid)
		resulting_text = TTF_RenderText_Solid(fonttodraw, text, tmpfontcolor);
	else if (quality == shaded)
		resulting_text = TTF_RenderText_Shaded(fonttodraw, text, tmpfontcolor, tmpfontbgcolor);
	else if (quality == blended)
		resulting_text = TTF_RenderText_Blended(fonttodraw, text, tmpfontcolor);
 
	return resulting_text;
}*/


// Disable Windows specifc code, while trying to get the code to run under Linux.
#ifdef CLOCK 

HDC		hDC=NULL;					// Private GDI Device Context
HGLRC		hRC=NULL;					// Permanent Rendering Context
HWND		hWnd=NULL;					// Holds Our Window Handle
HINSTANCE	hInstance;					// Holds The Instance Of The Application
GLuint	base;							// Base Display List For The Font Set


GLvoid KillFont(GLvoid)									// Delete The Font List
{
	glDeleteLists(base, 96);							// Delete All 96 Characters
}

GLvoid KillGLWindow(GLvoid)								// Properly Kill The Window
{
	if (hRC)											// Do We Have A Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					// Are We Able To Release The DC And RC Contexts?
		{
			MessageBox(NULL,"Release Of DC And RC Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						// Are We Able To Delete The RC?
		{
			MessageBox(NULL,"Release Rendering Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;										// Set RC To NULL
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					// Are We Able To Release The DC
	{
		MessageBox(NULL,"Release Device Context Failed.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;										// Set DC To NULL
	}

	if (hWnd && !DestroyWindow(hWnd))					// Are We Able To Destroy The Window?
	{
		MessageBox(NULL,"Could Not Release hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;										// Set hWnd To NULL
	}

	if (!UnregisterClass("OpenGL",hInstance))			// Are We Able To Unregister Class
	{
		MessageBox(NULL,"Could Not Unregister Class.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;									// Set hInstance To NULL
	}

	KillFont();
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			// Handle For This Window
							UINT	uMsg,			// Message For This Window
							WPARAM	wParam,			// Additional Message Information
							LPARAM	lParam)			// Additional Message Information
{	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

GLvoid BuildFont(GLvoid)								// Build Our Bitmap Font
{
	// make an hDC
	GLuint		PixelFormat;			// Holds The Results After Searching For A Match
	WNDCLASS	wc;						// Windows Class Structure
	hInstance			= GetModuleHandle(NULL);
	RECT		WindowRect;
	DWORD		dwExStyle;				// Window Extended Style
	DWORD		dwStyle;				// Window Style
	WindowRect.left=(long)0;			// Set Left Value To 0
	WindowRect.right=(long)500;		// Set Right Value To Requested Width
	WindowRect.top=(long)0;				// Set Top Value To 0
	WindowRect.bottom=(long)500;		// Set Bottom Value To Requested Height
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	// Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					// WndProc Handles Messages
//	wc.lpfnWndProc = NULL;
	wc.cbClsExtra		= 0;									// No Extra Window Data
	wc.cbWndExtra		= 0;									// No Extra Window Data
	wc.hInstance		= hInstance;							// Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			// Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			// Load The Arrow Pointer
	wc.hbrBackground	= NULL;									// No Background Required For GL
	wc.lpszMenuName		= NULL;									// We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								// Set The Class Name
	if (!RegisterClass(&wc))									// Attempt To Register The Window Class
	{
	//	printf("Failed to register the window class\n");
//		MessageBox(NULL,"Failed To Register The Window Class.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		exit(1);
	}
	dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			// Window Extended Style
	dwStyle=WS_OVERLAPPEDWINDOW;							// Windows Style
	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);

	if (!(hWnd=CreateWindowEx(	dwExStyle,							// Extended Style For The Window
								"OpenGL",							// Class Name
								"OpenGL",							// Window Title
								dwStyle |							// Defined Window Style
								WS_CLIPSIBLINGS |					// Required Window Style
								WS_CLIPCHILDREN,					// Required Window Style
								0, 0,								// Window Position
								WindowRect.right-WindowRect.left,	// Calculate Window Width
								WindowRect.bottom-WindowRect.top,	// Calculate Window Height
								NULL,								// No Parent Window
								NULL,								// No Menu
								hInstance,							// Instance
								NULL)))								// Dont Pass Anything To WM_CREATE
	{
		KillGLWindow();								// Reset The Display
	//	MessageBox(NULL,"Window Creation Error.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		exit(1);
	}

	static	PIXELFORMATDESCRIPTOR pfd=				// pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				// Size Of This Pixel Format Descriptor
		1,											// Version Number
		PFD_DRAW_TO_WINDOW |						// Format Must Support Window
		PFD_SUPPORT_OPENGL |						// Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							// Must Support Double Buffering
		PFD_TYPE_RGBA,								// Request An RGBA Format
		32,											// Select Our Color Depth
		0, 0, 0, 0, 0, 0,							// Color Bits Ignored
		0,											// No Alpha Buffer
		0,											// Shift Bit Ignored
		0,											// No Accumulation Buffer
		0, 0, 0, 0,									// Accumulation Bits Ignored
		16,											// 16Bit Z-Buffer (Depth Buffer)  
		0,											// No Stencil Buffer
		0,											// No Auxiliary Buffer
		PFD_MAIN_PLANE,								// Main Drawing Layer
		0,											// Reserved
		0, 0, 0										// Layer Masks Ignored
	};
	
	if (!(hDC=GetDC(hWnd)))							// Did We Get A Device Context?
	{
		KillGLWindow();								// Reset The Display
	//	MessageBox(NULL,"Can't Create A GL Device Context.","ERROR",MB_OK|MB_ICONEXCLAMATION);
		exit(1);
	}

	HFONT	font;										// Windows Font ID
	HFONT	oldfont;									// Used For Good House Keeping

	base = glGenLists(96);								// Storage For 96 Characters

	font = CreateFont(	-24,							// Height Of Font
						0,								// Width Of Font
						0,								// Angle Of Escapement
						0,								// Orientation Angle
						FW_BOLD,						// Font Weight
						FALSE,							// Italic
						FALSE,							// Underline
						FALSE,							// Strikeout
						ANSI_CHARSET,					// Character Set Identifier
						OUT_TT_PRECIS,					// Output Precision
						CLIP_DEFAULT_PRECIS,			// Clipping Precision
						ANTIALIASED_QUALITY,			// Output Quality
						FF_DONTCARE|DEFAULT_PITCH,		// Family And Pitch
						"Arial Black");					// Font Name
//	printf("Font: %X\n", font);

	oldfont = (HFONT)SelectObject(hDC, font);           // Selects The Font We Want
//	printf("OldFont: %X\n", oldfont);
	wglUseFontBitmaps(hDC, 32, 96, base);
//	printf("bitmaps: %X\n", wglUseFontBitmaps(hDC, 32, 96, base));				// Builds 96 Characters Starting At Character 32
	SelectObject(hDC, oldfont);
//	printf("Object: %X\n", SelectObject(hDC, oldfont));							// Selects The Font We Want
	DeleteObject(font);									// Delete The Font
}

GLvoid glPrint(const char *fmt, ...)					// Custom GL "Print" Routine
{
	char		text[256];								// Holds Our String
	va_list		ap;										// Pointer To List Of Arguments

	if (fmt == NULL)									// If There's No Text
		return;											// Do Nothing

	va_start(ap, fmt);									// Parses The String For Variables
	    vsprintf(text, fmt, ap);						// And Converts Symbols To Actual Numbers
	va_end(ap);											// Results Are Stored In Text

	glPushAttrib(GL_LIST_BIT);							// Pushes The Display List Bits
	glListBase(base - 32);								// Sets The Base Character to 32
	glCallLists(strlen(text), GL_UNSIGNED_BYTE, text);	// Draws The Display List Text
	glPopAttrib();										// Pops The Display List Bits
}

#endif

VizGrid::VizGrid() {
	for (int r = 0; r < FRAME_HEIGHT; r++)
		row_pointers[r] = (png_byte *)image[r];

	InitSDL();
	InitGL();
	InitPNG();
	InitVideo();

	timeindex = 0;
	totalgridtime = 0;
	totalcellslost = 0;
}

void VizGrid::InitSDL () {
	if (SDL_Init(SDL_INIT_VIDEO < 0)) exit(1);

	SDL_WM_SetCaption("Viz3D", 0);

	screen = SDL_SetVideoMode(FRAME_WIDTH, FRAME_HEIGHT, 0, SDL_OPENGL | SDL_HWSURFACE); //  | SDL_NOFRAME
	if (!screen) { SDL_Quit(); exit(3); }
}

void VizGrid::InitGL () {
	// View section
	float aspectratio = (float)FRAME_WIDTH / (float)FRAME_HEIGHT;
	glViewport(0, 0, FRAME_WIDTH, FRAME_HEIGHT);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
//	glOrtho(0, FRAME_WIDTH, FRAME_HEIGHT, 0, -1, 1); // 2d??
	gluPerspective(45.0f, aspectratio, 0.1f, 2000.0f);// was 500
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	// Misc parameters section
	glClearColor(0.0f, 0.0f, 0.0f, 0.0f);
	glClearDepth(1.0);
//	glDepthFunc(GL_LESS);
	glDepthFunc(GL_LEQUAL);
	glEnable(GL_DEPTH_TEST);
	glShadeModel(GL_SMOOTH);
//	glEnable(GL_POLYGON_SMOOTH);
	glFrontFace(GL_CCW);
	glCullFace(GL_BACK);
	glEnable(GL_CULL_FACE);

	// Colors and alpha
	glEnable(GL_COLOR_MATERIAL);
	glColorMaterial(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

	// texturing
//	GLint mysphereID;
	quadric = gluNewQuadric();
/*	gluQuadricTexture(quadric, 1);
	gluQuadricNormals(quadric, GLU_SMOOTH);
	glNewList(mysphereID, GL_COMPILE);
	gluSphere(quadric, 0.35, SPHERE_RES, SPHERE_RES);
	glEndList();*/
//	CreateSphere(70,0,0,0, 1.6);
	//glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	//glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
	//glEnable(GL_TEXTURE_GEN_S);
	//glEnable(GL_TEXTURE_GEN_T);
	glEnable( GL_TEXTURE_2D );

 sphere = gluNewQuadric();
 gluQuadricTexture(sphere, 1);
 gluQuadricNormals(sphere, GLU_SMOOTH);
 //Making a display list
 mysphereID = glGenLists(1);
 mysphereIDbig = glGenLists(1);
 mycylID = glGenLists(1);
		
 glNewList(mysphereID, GL_COMPILE);
 glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
 glScalef(1.0f, 1.0f, 2.0f);
 gluSphere(sphere, 0.35, SPHERE_RES, SPHERE_RES);
 glEndList();
 glNewList(mysphereIDbig, GL_COMPILE);
 gluSphere(sphere, 0.85, SPHERE_RES, SPHERE_RES);
 glEndList();
 glNewList(mycylID, GL_COMPILE);
 glRotatef(90.0f, 1.0f, 0.0f, 0.0f);
 gluCylinder(sphere, 0.4, 0.4, 1.0, 20, 10);
 glTranslatef(0.0f, 0.0f, 1.0f);
 gluDisk(sphere, 0.0f, 0.4f, SPHERE_RES, SPHERE_RES);
 glRotatef(180.0f, 1.0f, 0.0f, 0.0f);
 glTranslatef(0.0f, 0.0f, 1.0f);
 gluDisk(sphere, 0.0f, 0.4f, SPHERE_RES, SPHERE_RES);
 glEndList();
 gluDeleteQuadric(sphere);
 //-----------------
 //and whenever you want to render, call glCallList(mysphereID)
 //to kill the display list, glDeleteLists(mysphereID, 1);

	// fog
	GLint fogMode;
	glEnable(GL_FOG);
	GLfloat fogColor[4] = {0.0, 0.0, 0.0, 1.0};
    fogMode = GL_LINEAR;//EXP;
    glFogi(GL_FOG_MODE, fogMode);
    glFogfv(GL_FOG_COLOR, fogColor);
    glFogf(GL_FOG_DENSITY, 0.35);
    glHint(GL_FOG_HINT, GL_DONT_CARE);
    glFogf(GL_FOG_START, 200.0);
    glFogf(GL_FOG_END, 800.0);

	// Lighting section
	glEnable(GL_LIGHTING);
	GLfloat specular0[] = {1.0f, 1.0f, 1.0f, 1.0f};
	GLfloat diffuse0[] = {1.0f, 1.0f, 1.0f, 1.0f};
	GLfloat ambient0[] = {0.0f, 0.0f, 0.0f, 1.0f};
	GLfloat pos0[] = {300.0f, 300.0f, 500.0f, 0.0f};
	glLightfv(GL_LIGHT0, GL_SPECULAR, specular0);
	glLightfv(GL_LIGHT0, GL_DIFFUSE, diffuse0);
	glLightfv(GL_LIGHT0, GL_AMBIENT, ambient0);
	glLightfv(GL_LIGHT0, GL_POSITION, pos0);
	GLfloat specular1[] = {0.7f, 0.7f, 0.7f, 1.0f};
	GLfloat diffuse1[] = {0.7f, 0.7f, 0.7f, 1.0f};
	GLfloat ambient1[] = {0.0f, 0.0f, 0.0f, 1.0f};
	GLfloat pos1[] = {-300.0f, -300.0f, 500.0f, 0.0f};
	glLightfv(GL_LIGHT1, GL_SPECULAR, specular1);
	glLightfv(GL_LIGHT1, GL_DIFFUSE, diffuse1);
	glLightfv(GL_LIGHT1, GL_AMBIENT, ambient1);
	glLightfv(GL_LIGHT1, GL_POSITION, pos1);
	GLfloat global_ambient[] = {0.7f, 0.7f, 0.7f, 1.0f};
	//GLfloat global_ambient[] = {0.3f, 0.3f, 0.3f, 1.0f};
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, global_ambient);
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 1);
	glEnable(GL_LIGHT0);
	glEnable(GL_LIGHT1);
	
	// test***
	glEnable(GL_NORMALIZE);
	glPixelStorei(GL_UNPACK_ALIGNMENT, 1);
	glPixelStorei(GL_PACK_ALIGNMENT, 1);
	
	// allocate a texture name
	glGenTextures( 1, &texture );
	// select our current texture
	glBindTexture( GL_TEXTURE_2D, texture );
	// select modulate to mix texture with color for shading
	glTexEnvf( GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE );
	// when texture area is small, bilinear filter the closest mipmap
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER,
					 GL_LINEAR_MIPMAP_NEAREST );
	// when texture area is large, bilinear filter the original
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR );
	// the texture wraps over at the edges (repeat)
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT );
	glTexParameterf( GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT );
	
	int width, height;
	BYTE * data;
	FILE * file;
	// texture data
	width = 64;
	height = 64;
	// allocate buffer
	data = (BYTE *)malloc( width * height * 3 );
	// open and read texture data
	file = fopen( "small.raw", "rb" );
	fread( data, width * height * 3, 1, file );
	fclose( file );

	// build our texture mipmaps
	gluBuild2DMipmaps( GL_TEXTURE_2D, 3, width, height,
                   GL_RGB, GL_UNSIGNED_BYTE, data );
	// free buffer
	free( data );
	
//Disable Windows specifc code, while trying to get the code to run under Linux.
#ifdef CLOCK
	BuildFont();
#endif

/*	if (TTF_Init() == -1) {
		printf("Unable to initialize SDL_ttf: %s \n", TTF_GetError());
		exit(1);
	}

	timerfont = loadfont("arial.ttf", 24);*/
}


void VizGrid::InitPNG () {


}

void VizGrid::InitVideo() {
    avcodec_init();
    avcodec_register_all();

	pFrameRGB = avcodec_alloc_frame();
	avpicture_fill((AVPicture *)pFrameRGB, (uint8_t *)&image, PIX_FMT_RGB24, FRAME_WIDTH, FRAME_HEIGHT);
	assert(sizeof(image) == avpicture_get_size(PIX_FMT_RGB24, FRAME_WIDTH, FRAME_HEIGHT));
	
	video_convert_ctx = sws_getContext(
		FRAME_WIDTH, FRAME_HEIGHT, PIX_FMT_RGB24,
		FRAME_WIDTH, FRAME_HEIGHT, VIDEO_FMT,
		SWS_BICUBIC, NULL, NULL, NULL);
	if (video_convert_ctx == NULL) {
		fprintf(stderr, "Cannot initialize the conversion context!\n");
		exit(1);
	}
	
	codec = avcodec_find_encoder(CODEC_ID_MPEG2VIDEO); //CODEC_ID_FLV1 CODEC_ID_MPEG1VIDEO CODEC_ID_MPEG4
	if (!codec) {
		fprintf(stderr, "codec not found\n");
		exit(1);
	}

	c= avcodec_alloc_context();
	picture= avcodec_alloc_frame();

	/* put sample parameters */
	c->bit_rate = 2000000;
	/* resolution must be a multiple of two */
	c->width = FRAME_WIDTH;
	c->height = FRAME_HEIGHT;
	/* frames per second */
	//c->time_base= (AVRational){1,25};
	c->time_base.num = 1;
	c->time_base.den = 25;
	c->gop_size = 10; /* emit one intra frame every ten frames */
	//c->max_b_frames=1; // MPEG1
    c->max_b_frames = 2; // MPEG2
	c->pix_fmt = VIDEO_FMT;
	c->qmax = 15;
	c->qmin = 1;

	/* open it */
	if (avcodec_open(c, codec) < 0) {
		fprintf(stderr, "could not open codec\n");
		exit(1);
	}

	char filename[100] = "video.mpg";
	f = fopen(filename, "wb");
	if (!f) {
		fprintf(stderr, "could not open %s\n", filename);
		exit(1);
	}

	/* alloc image and output buffer */
	outbuf_size = 10000000; // 10 MB
	outbuf = (uint8_t *)malloc(outbuf_size);
	int size = c->width * c->height;
	picture_buf = (uint8_t *)malloc((size * 3) / 2); /* size for YUV 420 */

	picture->data[0] = picture_buf;
	picture->data[1] = picture->data[0] + size;
	picture->data[2] = picture->data[1] + size / 4;
	picture->linesize[0] = c->width;
	picture->linesize[1] = c->width / 2;
	picture->linesize[2] = c->width / 2;

	frame = 0;
}

coord VizGrid::applydir(coord current, int newdir) {
	coord outcoord = current;
	if (newdir >= 0 && newdir < 26) {
		outcoord.x += dirdelta[newdir].x;
		outcoord.y += dirdelta[newdir].y;
		outcoord.z += dirdelta[newdir].z;
	}

	if (outcoord.x < 0)
		outcoord.x = 0;
	if (outcoord.x >= LN_GRID_X)
		outcoord.x = LN_GRID_X - 1;
	if (outcoord.y < 0)
		outcoord.y = 0;
	if (outcoord.y >= LN_GRID_Y)
		outcoord.y = LN_GRID_Y - 1;
	if (outcoord.z < 0)
		outcoord.z = 0;
	if (outcoord.z >= LN_GRID_Z)
		outcoord.z = LN_GRID_Z - 1;

// Up:  0  1  2 x+y+z+
//   -x 5  4  3 y0
//      6  7  8 y-
// Md:  9 10 11 x+y+
//   -x13    12 z0
//     14 15 16 y-
// Dn: 17 18 19 z-
//     22 21 20
//     23 24 25
	return outcoord;
}

int VizGrid::getnumdirs(int dir) {
	if (nearbydirs[dir][7] == 77)
		return 7;
	else
		return 9;
}

void VizGrid::ExtractFrame(void) {
	glReadPixels(0, 0, FRAME_WIDTH, FRAME_HEIGHT, GL_RGB, GL_UNSIGNED_BYTE, image);
	// row are in reverse order, fix
	for (int q = 0; q < FRAME_HEIGHT / 2; q++) {
		for (int p = 0; p < FRAME_WIDTH; p++) {
			png_color temp = image[q][p];
			image[q][p] = image[FRAME_HEIGHT - 1 - q][p];
			image[FRAME_HEIGHT - 1 - q][p] = temp;
		}
	}
}

void VizGrid::WriteVideo() {
		sws_scale(video_convert_ctx, pFrameRGB->data,
			pFrameRGB->linesize, 0, FRAME_HEIGHT,
			picture->data, picture->linesize);

        // encode the image
        int out_size = avcodec_encode_video(c, outbuf, outbuf_size, picture);
        //printf("encoding frame %3d (size=%5d)\n", frame, out_size);
        fwrite(outbuf, 1, out_size, f);
        frame++;
}

void VizGrid::FinalizeVideo() {
	/* get the delayed frames */
    //for(; out_size; i++) {
	int out_size = 1;
	while (out_size) {
        fflush(stdout);

        out_size = avcodec_encode_video(c, outbuf, outbuf_size, NULL);
        printf("write frame %3d (size=%5d)\n", frame, out_size);
        fwrite(outbuf, 1, out_size, f);
    }

    /* add sequence end code to have a real mpeg file */
    outbuf[0] = 0x00;
    outbuf[1] = 0x00;
    outbuf[2] = 0x01;
    outbuf[3] = 0xb7;
    fwrite(outbuf, 1, 4, f);
    fclose(f);
    free(picture_buf);
    free(outbuf);

    avcodec_close(c);
    av_free(c);
    av_free(picture);
}
